`rake yard` does not work with Ruby >= 3.2
Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Gems support Estimated time: 0.00 hour

Target version: 5.1.1   

Resolution: Fixed Affected version:  

Description

`rake yard` which generates YARD documentation raises an exception and exits immediately after startup if the Ruby version is 3.2

or higher.

Please see error.txt.

Related issues:

Related to Redmine - Feature #38099: Add Ruby 3.2 support Closed

Associated revisions

Revision 22456 - 2023-11-18 05:18 - Go MAEDA

Fix `rake yard` does not work with Ruby >= 3.2 due to nested array issue (#39576).

Patch by Go MAEDA.

Revision 22463 - 2023-11-19 06:36 - Go MAEDA

Merged r22456 from trunk to 5.1-stable (#39576).

History

#1 - 2023-11-18 01:44 - Go MAEDA

- Subject changed from `rake yard` does not work with Ruby > 3.2 to `rake yard` does not work with Ruby >= 3.2

#2 - 2023-11-18 03:22 - Go MAEDA

- Target version set to 5.1.1

The following change fixes the issue.

The cause of this issue is that the current code creates a nested array by adding another array as a single element using the << operator. The

variable t.files expects a flat array, but the current implementation results in a nested array like ['app/**/*..rb',

["lib/generators/redmine_plugin/redmine_plugin_generator.rb", ...]].

Replacing << with += creates a flat array, aligning with the expected structure for t.files.

Index: lib/tasks/yardoc.rake

===================================================================

--- lib/tasks/yardoc.rake    (リビジョン 22450)

+++ lib/tasks/yardoc.rake    (作業コピー)

@@ -3,7 +3,7 @@

   YARD::Rake::YardocTask.new do |t|

     files = ['app/**/*.rb']

-    files << Dir['lib/**/*.rb', 'plugins/**/*.rb'].reject {|f| f.match(/test/) }

+    files += Dir['lib/**/*.rb', 'plugins/**/*.rb'].reject {|f| f.match(/test/)}

     t.files = files

     static_files = ['doc/CHANGELOG',

#3 - 2023-11-18 05:19 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA
Committed the patch in r22456.

#4 - 2023-11-19 06:37 - Go MAEDA

- Status changed from Resolved to Closed

- Resolution set to Fixed

#5 - 2023-11-19 06:54 - Go MAEDA

- Related to Feature #38099: Add Ruby 3.2 support added

Files
